# Written by Zachary Loman, Ph.D.
# U. of Maine
# 910-381-6368
# loman.zg@gmail.com
# Version 11/9/2020


# flatten data frame to vector of XML strings
df_to_XML<-function(df){
  start_tags<-sapply(colnames(df),FUN=function(x){paste0("<",x,">")})
  end_tags  <-sapply(colnames(df),FUN=function(x){paste0("</",x,">")})
  out<-list()
  for(i in 1:length(colnames(df))){
    out[[i]]<-paste0(start_tags[i],example[,i],end_tags[i])
  }
  return(do.call(paste0,args = out))
}

# convert Vector of XML strings to DF
x=testxml
XML_to_df<-function(x){
  tag_starts<-gregexpr("<",text =x[1])
  tag_ends<-gregexpr("</",text =x[1])
  start_tags<-unlist(tag_starts)[!(unlist(tag_starts)%in%unlist(tag_ends))]
  end_tags  <-unlist(tag_starts)[unlist(tag_starts)%in%unlist(tag_ends)]
  taglist<-list()
  for(k in 1:length(x)){
    temp<-list()
    for(i in 1:length(start_tags))
    {
      temp[[i]]<-substr(x[1],start=start_tags[i]+1,stop = unlist(gregexpr(">",x[1]))[2*i-1]-1)
    }
    taglist[[k]]<-temp
  }
  global_tags<-unique(unlist(taglist)) # all tags in all rows
  output_df<-as.data.frame(matrix(NA,nrow =length(x),ncol=length(global_tags)))
  colnames(output_df)<-global_tags
  
  for(m in 1:dim(x)[1])
  {
    for(j in 1:length(global_tags))
    {  
      output_df[m,j]<-unlist(strsplit(unlist(strsplit(x[m,],paste0("<",global_tags[j],">")))[2],paste0("</",global_tags[j],">")))[1]
    }
  }
return(output_df)
}


# Examples of use

data("BOD")
example   <-BOD
example$junk<-rnorm(6)
sample_out<-df_to_XML(example)
XML_to_df(sample_out)
